## odyssey 1.0.0

=== DESCRIPTION ===
Package: odyssey
Title: Interface to the HAL Open Archive API
Version: 1.0.0
Authors@R: c(
    person("Nicolas", "Frerebeau", , "nicolas.frerebeau@u-bordeaux-montaigne.fr", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-5759-4944")),
    person("Université Bordeaux Montaigne", role = "fnd",
           comment = c(ROR = "03pbgwk21"))
  )
Description: An interface to the search API of 'HAL'
    <https://hal.science/>, the French open archive for scholarly
    documents from all academic fields. This package provides programmatic
    access to the API <https://api.archives-ouvertes.fr/docs> and allows
    to search for records and download documents.
License: GPL (>= 3)
URL: https://codeberg.org/nfrerebeau/odyssey,
        https://nfrerebeau.r-universe.dev/odyssey,
        https://nfrerebeau.codeberg.page/odyssey/
BugReports: https://codeberg.org/nfrerebeau/odyssey/issues
Depends: R (>= 4.1)
Imports: httr2, rlang, utils
Suggests: tinytest
Encoding: UTF-8
RoxygenNote: 7.3.3
Collate: 'AllGenerics.R' 'hal_count.R' 'hal_download.R' 'hal_facet.R'
        'hal_filter.R' 'hal_group.R' 'hal_parse.R' 'hal_query.R'
        'hal_request.R' 'hal_search.R' 'hal_select.R' 'hal_sort.R'
        'odyssey-package.R' 'operators.R' 'zzz.R'
NeedsCompilation: no
Packaged: 2026-01-07 15:09:23 UTC; nfrerebeau
Author: Nicolas Frerebeau [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-5759-4944>),
  Université Bordeaux Montaigne [fnd] (ROR: <https://ror.org/03pbgwk21>)
Maintainer: Nicolas Frerebeau <nicolas.frerebeau@u-bordeaux-montaigne.fr>
Repository: CRAN
Date/Publication: 2026-01-08 19:30:02 UTC

## odyssey 1.5.0~rc

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(odyssey C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
    ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

set(CMAKE_C_STANDARD 23)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(OD_VERSION_GIT $ENV{VERSION})
if ("${OD_VERSION_GIT}" STREQUAL "")
    execute_process(COMMAND git rev-parse --short HEAD
                    OUTPUT_VARIABLE OD_VERSION_GIT
                    RESULT_VARIABLE OD_VERSION_GIT_RESULT
                    OUTPUT_STRIP_TRAILING_WHITESPACE)
    
    if(NOT "${OD_VERSION_GIT_RESULT}" STREQUAL "0")
        add_definitions(-DOD_VERSION_GIT="unknown")
    else()
        add_definitions(-DOD_VERSION_GIT="${OD_VERSION_GIT}")
    endif()
else()
    add_definitions(-DOD_VERSION_GIT="${OD_VERSION_GIT}")
endif()

set(OD_VERSION_NUMBER $ENV{BUILD_NUMBER})
if ("${OD_VERSION_NUMBER}" STREQUAL "")
    execute_process(COMMAND git rev-list --count HEAD
                    OUTPUT_VARIABLE OD_VERSION_NUMBER
                    RESULT_VARIABLE OD_VERSION_NUMBER_RESULT
                    OUTPUT_STRIP_TRAILING_WHITESPACE)

    if(NOT "${OD_VERSION_NUMBER_RESULT}" STREQUAL "0")
        add_definitions(-DOD_VERSION_NUMBER="unknown")
    else()
        add_definitions(-DOD_VERSION_NUMBER="${OD_VERSION_NUMBER}")
    endif()
else()
    add_definitions(-DOD_VERSION_NUMBER="${OD_VERSION_NUMBER}")
endif()
set(OD_VERSION_NUMBER "1.4.1-${OD_VERSION_NUMBER}")

set(OD_VERSION "${OD_VERSION_NUMBER}-${OD_VERSION_GIT}")

execute_process(COMMAND ${CMAKE_C_COMPILER} --version
        OUTPUT_VARIABLE OD_COMPILER_VERSION
        RESULT_VARIABLE OD_COMPILER_VERSION_RESULT
        OUTPUT_STRIP_TRAILING_WHITESPACE)


set(OD_DEVEL_LVL -1)

if ("${CMAKE_BUILD_TYPE}" STREQUAL "")
    set(CMAKE_BUILD_TYPE "Debug")
    set(OD_DEVEL_LVL 1)
endif()
if ("${CMAKE_BUILD_TYPE}" STREQUAL "Release")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic -Wall -Wextra -Werror -Wstrict-aliasing -g -O2 -pthread -D_GNU_SOURCE")
    set(OD_DEVEL_LVL -1)
elseif("${CMAKE_BUILD_TYPE}" STREQUAL "Debug")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic -Wall -Wextra -Werror -Wstrict-aliasing -g -O0 -pthread -D_GNU_SOURCE")
    set(OD_DEVEL_LVL 1)
elseif("${CMAKE_BUILD_TYPE}" STREQUAL "ASAN")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=address,undefined,leak -fno-sanitize-recover=all -fno-omit-frame-pointer -pedantic -Werror -Wall -Wextra -Wstrict-aliasing -g -O0 -pthread -D_GNU_SOURCE")
elseif("${CMAKE_BUILD_TYPE}" STREQUAL "TSAN")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=thread -fno-sanitize-recover=all -fno-omit-frame-pointer -pedantic -Wall -Werror -Wextra -Wstrict-aliasing -g -O0 -pthread -D_GNU_SOURCE")
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${CC_FLAGS}")

string(TOLOWER ${CMAKE_BUILD_TYPE} OD_VERSION_BUILD)
add_definitions(-DOD_VERSION_BUILD="${OD_VERSION_BUILD}")

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads REQUIRED)

add_custom_target(build_libs)
set(od_libraries "rt" "dl")

# postgresql
find_package(PostgreSQL)

if (POSTGRESQL_FOUND)
	set(od_libraries ${od_libraries} ${POSTGRESQL_LIBRARY} ${POSTGRESQL_LIBPGPORT} ${PQ_LIBRARY})
	include_directories(${POSTGRESQL_INCLUDE_DIR})
endif()

set(OPENSSL_INCLUDE_DIR $ENV{OPENSSL_INCLUDE_DIR})
set(OPENSSL_LIBRARIES $ENV{OPENSSL_LIBRARIES})
set(OPENSSL_VERSION $ENV{OPENSSL_VERSION})

# use BoringSSL or OpenSSL
option(USE_BORINGSSL "Use BoringSSL" OFF)
if (USE_BORINGSSL)
    find_package(BoringSSL REQUIRED)
    if (BORINGSSL_FOUND)
        set(od_ssl ${BORINGSSL_LIBRARIES})
        include_directories(${BORINGSSL_INCLUDE_DIR})
    endif ()
elseif ("${OPENSSL_LIBRARIES}" STREQUAL "")
    find_package(OpenSSL REQUIRED)
    set(od_ssl ${OPENSSL_LIBRARIES})
    include_directories(${OPENSSL_INCLUDE_DIR})
    add_definitions(-DUSE_SSL)
else ()	
    set(od_ssl ${OPENSSL_LIBRARIES})
    include_directories(${OPENSSL_INCLUDE_DIR})
    add_definitions(-DUSE_SSL)
endif ()

# use PAM
find_package(PAM)
if (PAM_FOUND)
    set(od_pam ${PAM_LIBRARY})
    include_directories(${PAM_INCLUDE_DIR})
endif()

set(od_libraries ${od_libraries} ${od_pam})

# use LDAP
find_package(LDAP)
if (LDAP_FOUND)
    set(od_ldap ${LDAP_LIBRARY})
    include_directories(${LDAP_INCLUDE_DIR})
endif()

set(od_libraries ${od_libraries} ${od_ldap})

# use Prom
find_package(Prom)
find_package(Promhttp)

if (PROM_FOUND AND PROMHTTP_FOUND)
    set(od_prom ${PROM_LIBRARY})
    include_directories(${PROM_INCLUDE_DIR})
    set(od_promhttp ${PROMHTTP_LIBRARY})
    include_directories(${PROMHTTP_INCLUDE_DIR})
endif()

set(od_libraries ${od_libraries} ${od_prom})
set(od_libraries ${od_libraries} ${od_promhttp})
set(od_libraries ${od_libraries} ${od_ssl})

#compression
option(BUILD_COMPRESSION "Build with compression support" OFF)
if(BUILD_COMPRESSION)
    set(compression_libraries "")
    add_definitions(-DMM_BUILD_COMPRESSION)
    # use zstd
    find_package(Zstd)
    if(ZSTD_FOUND)
        include_directories(${ZSTD_INCLUDE_DIR})
        set(compression_libraries ${compression_libraries} ${ZSTD_LIBRARY})
        add_definitions(-DMM_HAVE_ZSTD)
    endif()

    # use zlib
    find_package(ZLIB)
    if(ZLIB_FOUND)
        include_directories(${ZLIB_INCLUDE_DIRS})
        set(compression_libraries ${compression_libraries} ${ZLIB_LIBRARIES})
        add_definitions(-DMM_HAVE_ZLIB)
    endif()
endif()

message(STATUS "")
message(STATUS "Odyssey (version: ${OD_VERSION_NUMBER}-${OD_VERSION_GIT}-${OD_VERSION_BUILD})")
message(STATUS "")
message(STATUS "using compiler:         ${CMAKE_C_COMPILER} version ${OD_COMPILER_VERSION}")
message(STATUS "c lang standard:        ${CMAKE_C_STANDARD}")
message(STATUS "                                                                          ")
message(STATUS "CMAKE_BUILD_TYPE:       ${CMAKE_BUILD_TYPE}")
message(STATUS "CMAKE_C_FLAGS:          ${CMAKE_C_FLAGS}")
message(STATUS "BUILD_DEBIAN:           ${BUILD_DEBIAN}")
message(STATUS "USE_BORINGSSL:          ${USE_BORINGSSL}")
message(STATUS "BORINGSSL_ROOT_DIR:     ${BORINGSSL_ROOT_DIR}")
message(STATUS "BORINGSSL_INCLUDE_DIR:  ${BORINGSSL_INCLUDE_DIR}")
message(STATUS "OPENSSL_VERSION:        ${OPENSSL_VERSION}")
message(STATUS "OPENSSL_ROOT_DIR:       ${OPENSSL_ROOT_DIR}")
message(STATUS "OPENSSL_INCLUDE_DIR:    ${OPENSSL_INCLUDE_DIR}")
message(STATUS "OPENSSL_LIBRARIES:      ${OPENSSL_LIBRARIES}")

if (PAM_FOUND)
    message(STATUS "PAM_LIBRARY:            ${PAM_LIBRARY}")
    message(STATUS "PAM_INCLUDE_DIR:        ${PAM_INCLUDE_DIR}")
endif()


message(STATUS "POSTGRESQL_FOUND:       ${POSTGRESQL_FOUND}")
if (POSTGRESQL_FOUND)
    message(STATUS "POSTGRESQL_INCLUDE_DIR: ${POSTGRESQL_INCLUDE_DIR}")
    message(STATUS "POSTGRESQL_LIBRARY:     ${POSTGRESQL_LIBRARY}")
    message(STATUS "POSTGRESQL_LIBPGPORT:   ${POSTGRESQL_LIBPGPORT}")
    message(STATUS "PG_VERSION_NUM:         ${PG_VERSION_NUM}")
    message(STATUS "PQ_LIBRARY:             ${PQ_LIBRARY}")
endif()

message(STATUS "BUILD_COMPRESSION:      ${BUILD_COMPRESSION}")
if (BUILD_COMPRESSION)
    message(STATUS "ZSTD_INCLUDE_DIR:       ${ZSTD_INCLUDE_DIR}")
    message(STATUS "ZSTD_LIBRARY:           ${ZSTD_LIBRARY}")
    message(STATUS "ZLIB_INCLUDE_DIRS:      ${ZLIB_INCLUDE_DIRS}")
    message(STATUS "ZLIB_LIBRARIES:         ${ZLIB_LIBRARIES}")
endif()

    message(STATUS "LDAP_SUPPORT:           ${LDAP_FOUND}")
if (LDAP_FOUND)
    message(STATUS "LDAP_LIBRARY:           ${LDAP_LIBRARY}")
    message(STATUS "LDAP_INCLUDE_DIR:       ${LDAP_INCLUDE_DIR}")
endif()

add_subdirectory(sources)

set(OD_INSTALL_PREFIX "/usr/bin/")

install(TARGETS odyssey DESTINATION "${OD_INSTALL_PREFIX}")

include(Packaging)

=== Makefile ===
BUILD_TEST_DIR=build
BUILD_REL_DIR=build
BUILD_TEST_ASAN_DIR=build

FMT_BIN:=clang-format-18
CMAKE_BIN:=cmake

SKIP_CLEANUP_DOCKER:=

CMAKE_FLAGS:=-DCC_FLAGS="-Wextra -Wstrict-aliasing"
BUILD_TYPE=Release

DEV_CONF=./config-examples/odyssey-dev.conf

ODYSSEY_BUILD_TYPE ?= build_release
ODYSSEY_TEST_CODENAME ?= noble
ODYSSEY_TEST_POSTGRES_VERSION ?= 17
ODYSSEY_TEST_TARGET_PLATFORM ?= linux/$(shell uname -m)
ODYSSEY_ORACLELINUX_VERSION ?= 8
ODYSSEY_CC ?= gcc

CONCURRENCY:=1
CURRENT_USER_UID_GID:=$(shell id -u):$(shell id -g)
OS:=$(shell uname -s)
ifeq ($(OS), Linux)
	CONCURRENCY:=$(shell nproc)
endif
ifeq ($(OS), Darwin)
	CONCURRENCY:=$(shell sysctl -n hw.logicalcpu')
endif

.PHONY: clean apply_fmt

clean:
	rm -fr $(BUILD_REL_DIR)
	rm -fr $(BUILD_TEST_DIR)
	rm -fr $(BUILD_TEST_ASAN_DIR)

local_build: clean
	+$(CMAKE_BIN) -B$(BUILD_TEST_DIR) -DCMAKE_BUILD_TYPE=$(BUILD_TYPE) $(CMAKE_FLAGS)
	+make -C$(BUILD_TEST_DIR) -j$(CONCURRENCY)

local_run: 
	$(BUILD_TEST_DIR)/sources/odyssey $(DEV_CONF)

console_run: 
	$(BUILD_TEST_DIR)/sources/odyssey $(DEV_CONF) --verbose --console --log_to_stdout

check-format:
	docker build -f docker/format/Dockerfile --tag=odyssey/clang-format-runner .
	docker run -v .:/odyssey:ro odyssey/clang-format-runner modules sources

format:
	docker build -f docker/format/Dockerfile --tag=odyssey/clang-format-runner .
	docker run --user=`stat -c "%u:%g" .` -v .:/odyssey:rw odyssey/clang-format-runner -i modules sources

build_asan:
	mkdir -p $(BUILD_TEST_ASAN_DIR)
	cd $(BUILD_TEST_ASAN_DIR) && $(CMAKE_BIN) .. -DCMAKE_BUILD_TYPE=ASAN $(CMAKE_FLAGS) && make -j$(CONCURRENCY)

build_release:
	mkdir -p $(BUILD_REL_DIR)
	cd $(BUILD_REL_DIR) && $(CMAKE_BIN) .. -DCMAKE_BUILD_TYPE=Release $(CMAKE_FLAGS) && make -j$(CONCURRENCY)

build_dbg:
	mkdir -p $(BUILD_TEST_DIR)
	cd $(BUILD_TEST_DIR) && $(CMAKE_BIN) .. -DCMAKE_BUILD_TYPE=Debug && make -j$(CONCURRENCY)

gdb: build_dbg
	gdb --args ./build/sources/odyssey $(DEV_CONF)  --verbose --console --log_to_stdout

submit-cov:
	mkdir cov-build && cd cov-build
	$(COV-BIN-PATH)/cov-build --dir cov-int make -j 4 && tar czvf odyssey.tgz cov-int && curl --form token=$(COV_TOKEN) --form email=$(COV_ISSUER) --form file=@./odyssey.tgz --form version="2" --form description="scalable potgresql connection pooler"  https://scan.coverity.com/builds\?project\=yandex%2Fodyssey

cpack-deb: build_release
	cd $(BUILD_REL_DIR) && cpack -G DEB

cpack-deb-debug: build_dbg
	cd $(BUILD_REL_DIR) && cpack -G DEB

cpack-rpm: build_release
	cd $(BUILD_REL_DIR) && cpack -G RPM

cpack-rpm-debug: build_dbg
	cd $(BUILD_REL_DIR) && cpack -G RPM

package-bionic:
	mkdir -p build
	./docker/dpkg/runner.sh -c bionic -o build

package-jammy:
	mkdir -p build
	./docker/dpkg/runner.sh -c jammy -o build

install:
	install -D build/sources/odyssey $(DESTDIR)/usr/bin/odyssey

quickstart:
	docker build -f docker/quickstart/Dockerfile . --tag=odyssey
	docker run -d \
		--rm \
		--name "odyssey" \
		-p "6432:6432" \
	 	-v ./docker/quickstart/config.conf:/etc/odyssey/odyssey.conf \
		odyssey

dev_run: format local_build console_run

start-dev-env-release:
	docker compose -f ./docker/functional/docker-compose.yml down || true
	ODYSSEY_FUNCTIONAL_BUILD_TYPE=build_release \
	ODYSSEY_TEST_TARGET=dev-env \
	docker compose -f ./docker/functional/docker-compose.yml up --force-recreate --build -d --remove-orphans

start-dev-env-dbg:
	docker compose -f ./docker/functional/docker-compose.yml down || true
	ODYSSEY_FUNCTIONAL_BUILD_TYPE=build_dbg \
	ODYSSEY_TEST_TARGET=dev-env \
	docker compose -f ./docker/functional/docker-compose.yml up --force-recreate --build -d --remove-orphans

start-dev-env-asan:
	docker compose -f ./docker/functional/docker-compose.yml down || true
	ODYSSEY_FUNCTIONAL_BUILD_TYPE=build_asan \
	ODYSSEY_TEST_TARGET=dev-env \
	docker compose -f ./docker/functional/docker-compose.yml up --force-recreate --build -d --remove-orphans

quickstart_test:
	docker build -f docker/quickstart/Dockerfile . --tag=odyssey
	docker compose -f ./docker/quickstart/test/docker-compose.yml up --exit-code-from tester --force-recreate --build --remove-orphans

prometheus-legacy-test:
	docker compose -f ./docker/prometheus-legacy/docker-compose.yml down || true
	ODYSSEY_PROM_BUILD_TYPE=$(ODYSSEY_BUILD_TYPE) \
	docker compose -f ./docker/prometheus-legacy/docker-compose.yml up --exit-code-from odyssey --force-recreate --build --remove-orphans

soft-oom-test:
	docker compose -f ./docker/oom/docker-compose.yml down || true
	docker build -f docker/oom/Dockerfile . --tag=odyssey
	docker compose -f ./docker/oom/docker-compose.yml up --exit-code-from runner --force-recreate --build --remove-orphans

prom-exporter-test:
	docker build -f docker/quickstart/Dockerfile . --tag=odyssey
	docker compose -f ./docker/prom-exporter/docker-compose.yml up --exit-code-from tester --force-recreate --build --remove-orphans

functional-test:
	ODYSSEY_FUNCTIONAL_BUILD_TYPE=$(ODYSSEY_BUILD_TYPE) \
	ODYSSEY_TEST_TARGET=functional-entrypoint \
	ODYSSEY_FUNCTIONAL_TESTS_SELECTOR="$(ODYSSEY_TEST_SELECTOR)" \
	ODYSSEY_CC="$(ODYSSEY_CC)" \
	docker compose -f ./docker/functional/docker-compose.yml up --exit-code-from odyssey --build --remove-orphans

jemalloc-test:
	docker compose -f ./docker/jeamalloc/docker-compose.yml down || true
	ODYSSEY_JEMALLOC_BUILD_TYPE=$(ODYSSEY_BUILD_TYPE) \
	docker compose -f ./docker/jemalloc/docker-compose.yml up --exit-code-from runner --build --remove-orphans

stress-tests:
	docker compose -f ./docker/stress/docker-compose.yml down || true

	ODYSSEY_STRESS_BUILD_TYPE=$(ODYSSEY_BUILD_TYPE) \
	ODYSSEY_STRESS_TEST_TARGET=stress-entrypoint \
	docker compose -f ./docker/stress/docker-compose.yml up --exit-code-from runner --build --remove-orphans

stress-tests-dev-env:
	docker compose -f ./docker/stress/docker-compose.yml down || true

	ODYSSEY_STRESS_BUILD_TYPE=build_release \
	ODYSSEY_STRESS_TEST_TARGET=dev-env \
	docker compose -f ./docker/stress/docker-compose.yml up --force-recreate --build -d --remove-orphans

stress-tests-dev-env-dbg:
	docker compose -f ./docker/stress/docker-compose.yml down || true

	ODYSSEY_STRESS_BUILD_TYPE=build_dbg \
	ODYSSEY_STRESS_TEST_TARGET=dev-env \
	docker compose -f ./docker/stress/docker-compose.yml up --force-recreate --build -d --remove-orphans

ci-unittests:
	docker build \
		--platform $(ODYSSEY_TEST_TARGET_PLATFORM) \
		-f ./docker/unit/Dockerfile \
		--build-arg build_type=$(ODYSSEY_BUILD_TYPE) \
		--build-arg odyssey_cc=$(ODYSSEY_CC) \
		--tag=odyssey/unit-test-runner .
	docker run odyssey/unit-test-runner

ci-build-check-ubuntu:
	docker build \
		--platform $(ODYSSEY_TEST_TARGET_PLATFORM) \
		-f docker/build-test/Dockerfile.ubuntu \
		--build-arg codename=$(ODYSSEY_TEST_CODENAME) \
		--build-arg postgres_version=$(ODYSSEY_TEST_POSTGRES_VERSION) \
		--tag=odyssey/$(ODYSSEY_TEST_CODENAME)-pg$(ODYSSEY_TEST_POSTGRES_VERSION)-builder-$(ODYSSEY_TEST_TARGET_PLATFORM) .
	docker run -e ODYSSEY_BUILD_TYPE=$(ODYSSEY_BUILD_TYPE) odyssey/$(ODYSSEY_TEST_CODENAME)-pg$(ODYSSEY_TEST_POSTGRES_VERSION)-builder-$(ODYSSEY_TEST_TARGET_PLATFORM)

ci-build-check-fedora:
	docker build \
		-f docker/build-test/Dockerfile.fedora \
		--tag=odyssey/fedora-img .

ci-build-check-oracle-linux:
	docker build \
		-f docker/build-test/Dockerfile.oraclelinux \
		--build-arg version=$(ODYSSEY_ORACLELINUX_VERSION) \
		--tag=odyssey/oraclelinux-$(ODYSSEY_ORACLELINUX_VERSION)-pg$(ODYSSEY_TEST_POSTGRES_VERSION)-builder .
	docker run -e ODYSSEY_BUILD_TYPE=$(ODYSSEY_BUILD_TYPE) odyssey/oraclelinux-$(ODYSSEY_ORACLELINUX_VERSION)-pg$(ODYSSEY_TEST_POSTGRES_VERSION)-builder

build-docs-web:
	docker build -f docs/Dockerfile --tag=odyssey/docs-builder .
	docker run --user="$(CURRENT_USER_UID_GID)" -v .:/odyssey:rw odyssey/docs-builder

serve-docs: build-docs-web
	docker stop odyssey_docs_web || true
	docker run \
		-it --rm \
		--name odyssey_docs_web \
		-p "80:80" -p "443:443" \
		-v "${PWD}/site:/usr/share/nginx/html:ro" \
		-v "${PWD}/docs/nginx.conf:/etc/nginx/nginx.conf:ro" \
		-v "${PWD}/certificate.pem":/etc/certificate.pem:ro \
		-d nginx:alpine

=== sources/CMakeLists.txt ===
configure_file("include/build.h.cmake" "build.h")
configure_file("include/machinarium/build.h.cmake" "machinarium/build.h")

set(od_binary ${CMAKE_PROJECT_NAME})
set(od_src
    kiwi/md5.c
    kiwi/options.c
    machinarium/ds/vrb.c
    machinarium/thread.c
    machinarium/lrand48.c
    machinarium/loop.c
    machinarium/clock.c
    machinarium/socket.c
    machinarium/stat.c
    machinarium/epoll.c
    machinarium/context_stack.c
    machinarium/context.c
    machinarium/coroutine.c
    machinarium/coroutine_cache.c
    machinarium/scheduler.c
    machinarium/call.c
    machinarium/signal_mgr.c
    machinarium/event_mgr.c
    machinarium/machine.c
    machinarium/mm.c
    machinarium/machine_mgr.c
    machinarium/msg_cache.c
    machinarium/msg.c
    machinarium/mutex.c
    machinarium/memory.c
    machinarium/channel.c
    machinarium/channel_api.c
    machinarium/task_mgr.c
    machinarium/tls.c
    machinarium/io.c
    machinarium/iov.c
    machinarium/close.c
    machinarium/connect.c
    machinarium/bind.c
    machinarium/backtrace.c
    machinarium/eventfd.c
    machinarium/cond.c
    machinarium/read.c
    machinarium/write.c
    machinarium/accept.c
    machinarium/ring_buffer.c
    machinarium/shutdown.c
    machinarium/dns.c
    machinarium/wait_list.c
    machinarium/wait_flag.c
    machinarium/wait_group.c
    machinarium/zpq_stream.c
    machinarium/compression.c
    machinarium/cert_hash.c
    od_memory.c
    daemon.c
    pid.c
    logger.c
    pool.c
    rules.c
    config.c
    config_reader.c
    dns.c
    router.c
    global.c
    system.c
    cron.c
    worker.c
    tls.c
    attribute.c
    auth_query.c
    auth.c
    cancel.c
    client.c
    relay.c
    console.c
    deploy.c
    reset.c
    frontend.c
    backend_sync.c
    backend.c
    instance.c
    misc.c
    tdigest.c
    module.c
    attach.c
    multi_pool.c
    counter.c
    err_logger.c
    setproctitle.c
    debugprintf.c
    restart_sync.c
    soft_oom.c
    grac_shutdown_worker.c
    sighandler.c
    watchdog.c
    ejection.c
    thread_global.c
    host_watcher.c
    compression.c
    option.c
    tls_config.c
    tsa.c
    query.c
    storage.c
    server.c
    murmurhash.c
    hashmap.c
    address.c
    hba.c
    hba_reader.c
    hba_rule.c
    mdb_iamproxy.c
    external_auth.c
    group.c
    query_processing.c)

if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|AMD64")
    set_property(SOURCE machinarium/context_swap_x64.S PROPERTY LANGUAGE C)
    list(APPEND od_src machinarium/context_swap_x64.S)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86|i.86")
    set_property(SOURCE machinarium/context_swap_x32.S PROPERTY LANGUAGE C)
    list(APPEND od_src machinarium/context_swap_x32.S)
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "arm|ARM|aarch64")
    set_property(SOURCE machinarium/context_swap_aarch64.S PROPERTY LANGUAGE C)
    list(APPEND od_src machinarium/context_swap_aarch64.S)
else()
    message(FATAL_ERROR "Unsupported architecture: ${CMAKE_SYSTEM_PROCESSOR}")
endif()

if (PAM_FOUND)
    list(APPEND od_src pam.c)
endif()

if (POSTGRESQL_FOUND)
	list(APPEND od_src scram.c)
endif()

if (LDAP_FOUND)
        list(APPEND od_src ldap.c)
endif()

if (PROM_FOUND)
        list(APPEND od_src prom_metrics.c)
endif()

include_directories("${PROJECT_SOURCE_DIR}/")
include_directories("${PROJECT_SOURCE_DIR}/sources")
include_directories("${PROJECT_SOURCE_DIR}/sources/include")
include_directories("${PROJECT_BINARY_DIR}/")
include_directories("${PROJECT_BINARY_DIR}/sources")
include_directories("${PROJECT_BINARY_DIR}/sources/include")

add_executable(${od_binary} ${od_src} main.c)
add_dependencies(${od_binary} build_libs)

if(THREADS_HAVE_PTHREAD_ARG)
    set_property(TARGET ${od_binary} PROPERTY COMPILE_OPTIONS "-pthread")
    set_property(TARGET ${od_binary} PROPERTY INTERFACE_COMPILE_OPTIONS "-pthread")
endif()

target_link_libraries(${od_binary} ${od_libraries} ${CMAKE_THREAD_LIBS_INIT} m)
if(EXISTS "/etc/alpine-release")
    target_link_libraries(${od_binary} argp)
endif()

if (BUILD_COMPRESSION)
    target_link_libraries(${od_binary} ${compression_libraries})
endif()


# Unit test building

set(od_test_binary odyssey_test)
set(od_test_src
    tests/odyssey_test.c
    tests/kiwi/test_kiwi_enquote.c
    tests/kiwi/test_kiwi_pgoptions.c
    tests/machinarium/test_init.c
    tests/machinarium/test_create0.c
    tests/machinarium/test_create1.c
    tests/machinarium/test_config.c
    tests/machinarium/test_context_switch.c
    tests/machinarium/test_sleep.c
    tests/machinarium/test_sleep_yield.c
    tests/machinarium/test_sleep_cancel0.c
    tests/machinarium/test_join.c
    tests/machinarium/test_condition0.c
    tests/machinarium/test_eventfd.c
    tests/machinarium/test_stat.c
    tests/machinarium/test_signal0.c
    tests/machinarium/test_signal1.c
    tests/machinarium/test_signal2.c
    tests/machinarium/test_channel_create.c
    tests/machinarium/test_channel_rw0.c
    tests/machinarium/test_channel_rw1.c
    tests/machinarium/test_channel_rw2.c
    tests/machinarium/test_channel_rw3.c
    tests/machinarium/test_channel_rw4.c
    tests/machinarium/test_channel_timeout.c
    tests/machinarium/test_channel_cancel.c
    tests/machinarium/test_channel_shared_create.c
    tests/machinarium/test_channel_shared_rw0.c
    tests/machinarium/test_channel_shared_rw1.c
    tests/machinarium/test_channel_shared_rw2.c
    tests/machinarium/test_sleeplock.c
    tests/machinarium/test_producer_consumer0.c
    tests/machinarium/test_producer_consumer1.c
    tests/machinarium/test_producer_consumer2.c
    tests/machinarium/test_io_new.c
    tests/machinarium/test_connect.c
    tests/machinarium/test_connect_timeout.c
    tests/machinarium/test_connect_cancel0.c
    tests/machinarium/test_connect_cancel1.c
    tests/machinarium/test_accept_timeout.c
    tests/machinarium/test_accept_cancel.c
    tests/machinarium/test_advice_keepalive_usr_timeout.c
    tests/machinarium/test_wait_list_compare_wait_timeout.c
    tests/machinarium/test_wait_list_notify_after_compare_wait.c
    tests/machinarium/test_wait_list_compare_wait_wrong_value.c
    tests/machinarium/test_wait_list_without_notify.c
    tests/machinarium/test_wait_list_notify_after_wait.c
    tests/machinarium/test_wait_list_one_producer_multiple_consumers.c
    tests/machinarium/test_wait_list_one_producer_multiple_consumers_threads.c
    tests/machinarium/test_wait_list_notify_all.c
    tests/machinarium/test_wait_group_simple.c
    tests/machinarium/test_wait_group_timeout.c
    tests/machinarium/test_wait_group_lifetime.c
    tests/machinarium/test_wait_flag_simple.c
    tests/machinarium/test_wait_flag_timeout.c
    tests/machinarium/test_getaddrinfo0.c
    tests/machinarium/test_getaddrinfo1.c
    tests/machinarium/test_getaddrinfo2.c
    tests/machinarium/test_client_server0.c
    tests/machinarium/test_client_server1.c
    tests/machinarium/test_client_server2.c
    tests/machinarium/test_client_server_unix_socket.c
    tests/machinarium/test_client_server_unix_socket_no_msg.c
    tests/machinarium/test_coroutine_names.c
    tests/machinarium/test_mutex_threads.c
    tests/machinarium/test_mutex_coroutines.c
    tests/machinarium/test_mutex_timeout.c
    tests/machinarium/test_read_10mb0.c
    tests/machinarium/test_read_10mb1.c
    tests/machinarium/test_read_10mb2.c
    tests/machinarium/test_read_timeout.c
    tests/machinarium/test_read_cancel.c
    tests/machinarium/test_read_var.c
    tests/machinarium/test_ring_buffer.c
    tests/machinarium/test_tls0.c
    tests/machinarium/test_tls_unix_socket.c
    tests/machinarium/test_tls_unix_socket_no_msg.c
    tests/machinarium/test_tls_read_10mb0.c
    tests/machinarium/test_tls_read_10mb1.c
    tests/machinarium/test_tls_read_10mb2.c
    tests/machinarium/test_tls_read_multithread.c
    tests/machinarium/test_tls_read_var.c
    tests/machinarium/test_vrb.c
    tests/odyssey/test_attribute.c
    tests/odyssey/test_tdigest.c
    tests/odyssey/test_util.c
    tests/odyssey/test_locks.c
    tests/odyssey/test_hba_parse.c
    tests/odyssey/test_address.c
    tests/odyssey/test_hashmap.c)

include_directories("${PROJECT_SOURCE_DIR}/tests")
include_directories("${PROJECT_BINARY_DIR}/tests")

file(COPY tests/machinarium/ca.crt DESTINATION machinarium)
file(COPY tests/machinarium/client.crt DESTINATION machinarium)
file(COPY tests/machinarium/client.key DESTINATION machinarium)
file(COPY tests/machinarium/server.crt DESTINATION machinarium)
file(COPY tests/machinarium/server.key DESTINATION machinarium)

add_executable(${od_test_binary} ${od_test_src} ${od_src})
add_dependencies(${od_test_binary} build_libs)

if(THREADS_HAVE_PTHREAD_ARG)
    set_property(TARGET ${od_test_binary} PROPERTY COMPILE_OPTIONS "-pthread")
    set_property(TARGET ${od_test_binary} PROPERTY INTERFACE_COMPILE_OPTIONS "-pthread")
endif()

target_link_libraries(${od_test_binary} ${od_libraries} ${CMAKE_THREAD_LIBS_INIT} m)

if(EXISTS "/etc/alpine-release")
    target_link_libraries(${od_test_binary} argp)
endif()

if (BUILD_COMPRESSION)
    target_link_libraries(${od_test_binary} ${compression_libraries})
endif()

=== debian/changelog ===
odyssey (1.5.0~rc-1) unstable; urgency=low

  * Initial release.
  * Package contains assembler for x64 and aarch64, hence restrict to amd64
    and arm64 only.

 -- Christoph Berg <myon@debian.org>  Fri, 16 Jan 2026 11:11:49 +0100

=== debian/control ===
Source: odyssey
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Christoph Berg <myon@debian.org>,
Standards-Version: 4.7.3
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-installsysusers,
 cmake,
 libpam-dev,
 libpq-dev,
 libssl-dev (>= 1.0.1),
 libsystemd-dev,
 libzstd-dev,
 zlib1g-dev,
Vcs-Browser: https://salsa.debian.org/postgresql/odyssey
Vcs-Git: https://salsa.debian.org/postgresql/odyssey.git
Homepage: https://github.com/yandex/odyssey

Package: odyssey
Architecture: amd64 arm64
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Scalable PostgreSQL connection pooler
 Odyssey is an advanced multi-threaded PostgreSQL connection pooler and request
 router.
 .
 Multi-threaded processing
 .
 Odyssey can significantly scale processing performance by specifying a number
 of additional worker threads. Each worker thread is responsible for
 authentication and proxying client-to-server and server-to-client requests.
 All worker threads are sharing global server connection pools. Multi-threaded
 design plays important role in SSL/TLS performance.
 .
 Advanced transactional pooling
 .
 Odyssey tracks current transaction state and in case of unexpected client
 disconnection can emit automatic Cancel connection and do Rollback of
 abandoned transaction, before putting server connection back to the server
 pool for reuse. Additionally, last server connection owner client is
 remembered to reduce a need for setting up client options on each
 client-to-server assignment.
